 /*Unless otherwise indicated, all materials on these pages are  Copyright 2005 Priyank Bolia. 
 All rights reserved. No part of these pages, either text or image may be used for any purpose
 other than personal use. Therefore, reproduction, modification, storage in a retrieval system
 or retransmission, in any form or by any means, electronic, mechanical, or otherwise, for reasons
 other than personal use, is strictly prohibited without prior written permission.*/

function GETDATE()
{
	var currentTime = new Date();
	var month = currentTime.getMonth() + 1;
	var day = currentTime.getDate();
	var year = currentTime.getFullYear();
	var strDATE = day + "/" + month + "/" + year;
	wizard.AddSymbol('PROJECT_DATE', strDATE);
}

function OnFinish(selProj, selObj)
{
	GETDATE();
	try
	{
		var strProjectPath = wizard.FindSymbol('PROJECT_PATH');
		var strProjectName = wizard.FindSymbol('PROJECT_NAME');

		selProj = CreateCustomProject(strProjectName, strProjectPath);
		AddConfig(selProj, strProjectName);
		AddFilters(selProj);

		var InfFile = CreateCustomInfFile();
		AddFilesToCustomProj(selProj, strProjectName, strProjectPath, InfFile);
		PchSettings(selProj);
		InfFile.Delete();

		selProj.Object.Save();
	}
	catch(e)
	{
		if (e.description.length != 0)
			SetErrorInfo(e);
		return e.number
	}
}

function CreateCustomProject(strProjectName, strProjectPath)
{
	try
	{
		var strProjTemplatePath = wizard.FindSymbol('PROJECT_TEMPLATE_PATH');
		var strProjTemplate = '';
		strProjTemplate = strProjTemplatePath + '\\default.vcproj';

		var Solution = dte.Solution;
		var strSolutionName = "";
		if (wizard.FindSymbol("CLOSE_SOLUTION"))
		{
			Solution.Close();
			strSolutionName = wizard.FindSymbol("VS_SOLUTION_NAME");
			if (strSolutionName.length)
			{
				var strSolutionPath = strProjectPath.substr(0, strProjectPath.length - strProjectName.length);
				Solution.Create(strSolutionPath, strSolutionName);
			}
		}

		var strProjectNameWithExt = '';
		strProjectNameWithExt = strProjectName + '.vcproj';

		var oTarget = wizard.FindSymbol("TARGET");
		var prj;
		if (wizard.FindSymbol("WIZARD_TYPE") == vsWizardAddSubProject)  // vsWizardAddSubProject
		{
			var prjItem = oTarget.AddFromTemplate(strProjTemplate, strProjectNameWithExt);
			prj = prjItem.SubProject;
		}
		else
		{
			prj = oTarget.AddFromTemplate(strProjTemplate, strProjectPath, strProjectNameWithExt);
		}
		return prj;
	}
	catch(e)
	{
		throw e;
	}
}

function AddFilters(proj)
{
	try
	{
        // Add the folders to your project
        var strSrcFilter1 = wizard.FindSymbol('SOURCE_FILTER');
        var strSrcFilter2 = wizard.FindSymbol('HEADER_FILTER');
        var strSrcFilter3 = wizard.FindSymbol('RESOURCE_FILTER');
        
        var group1 = proj.Object.AddFilter('Source Files');
        var group2 = proj.Object.AddFilter('Header Files');
        var group3 = proj.Object.AddFilter('Resource Files');
        
		group1.Filter = strSrcFilter1;
        group2.Filter = strSrcFilter2;
        group3.Filter = strSrcFilter3;
	}
	catch(e)
	{
		throw e;
	}
}

function AddConfig(proj, strProjectName)
{
	try
	{
		var config = proj.Object.Configurations('Debug');
		config.IntermediateDirectory = 'Debug';
		config.OutputDirectory = 'Debug';

		if(wizard.FindSymbol('UNICODE_ENABLED_CHECKBOX'))
		{
			config.CharacterSet = charSetUnicode;
			if(wizard.FindSymbol('DLL_APPLICATION_RADIO'))
			{
				config.ConfigurationType  = typeDynamicLibrary;
			}
		}
		else
		{
			config.CharacterSet = charSetNotSet;
			if(wizard.FindSymbol('DLL_APPLICATION_RADIO'))
			{
				config.ConfigurationType  = typeDynamicLibrary;
			}
		}


		var CLTool = config.Tools('VCCLCompilerTool');
		CLTool.SuppressStartupBanner=true;
		CLTool.RuntimeLibrary=runtimeLibraryOption.rtMultiThreadedDebugDLL;
		CLTool.WarningLevel=warningLevelOption.warningLevel_3;
		CLTool.Optimization=optimizeOption.optimizeDisabled;
		CLTool.MinimalRebuild=true;
		CLTool.DebugInformationFormat=debugOption.debugEditAndContinue;
		if(wizard.FindSymbol('USE_DYNAMIC_LIBRARY_RADIO'))
			if(wizard.FindSymbol('UNICODE_ENABLED_CHECKBOX'))
				CLTool.AdditionalIncludeDirectories = "\""+wizard.FindSymbol('WXDIR')+"\\include\";\""+wizard.FindSymbol('WXDIR')+"\\lib\\vc_dll\\mswud\";\""+wizard.FindSymbol('WXDIR')+"\\contrib\\include\"";
			else
				CLTool.AdditionalIncludeDirectories = "\""+wizard.FindSymbol('WXDIR')+"\\include\";\""+wizard.FindSymbol('WXDIR')+"\\lib\\vc_dll\\mswd\";\""+wizard.FindSymbol('WXDIR')+"\\contrib\\include\"";
		else
			if(wizard.FindSymbol('UNICODE_ENABLED_CHECKBOX'))
				CLTool.AdditionalIncludeDirectories = "\""+wizard.FindSymbol('WXDIR')+"\\include\";\""+wizard.FindSymbol('WXDIR')+"\\lib\\vc_lib\\mswud\";\""+wizard.FindSymbol('WXDIR')+"\\contrib\\include\"";
			else
				CLTool.AdditionalIncludeDirectories = "\""+wizard.FindSymbol('WXDIR')+"\\include\";\""+wizard.FindSymbol('WXDIR')+"\\lib\\vc_lib\\mswd\";\""+wizard.FindSymbol('WXDIR')+"\\contrib\\include\"";
		
		if(wizard.FindSymbol('UNICODE_ENABLED_CHECKBOX'))
			if(wizard.FindSymbol('USE_DYNAMIC_LIBRARY_RADIO'))
				if(wizard.FindSymbol('WINDOWS_APPLICATION_RADIO'))
					CLTool.PreprocessorDefinitions = "wxUSE_UNICODE=1;WIN32;_DEBUG;__WXDEBUG__;WXDEBUG=1;__WIN32__;__WXMSW__;WINVER=0x0400;WXUSINGDLL;STRICT;";
				else if(wizard.FindSymbol('DLL_APPLICATION_RADIO'))
					CLTool.PreprocessorDefinitions = "wxUSE_UNICODE=1;WIN32;_DEBUG;__WXDEBUG__;WXDEBUG=1;__WIN32__;__WXMSW__;WINVER=0x0400;WXUSINGDLL;STRICT;_USRDLL;WXMAKINGDLL_" + strProjectName + ";" + strProjectName + "DLL_EXPORTS";
				else
					CLTool.PreprocessorDefinitions = "wxUSE_UNICODE=1;WIN32;__WIN32__;_DEBUG;__WXMSW__;__WXDEBUG__;_CONSOLE;wxUSE_GUI=0;WXUSINGDLL;STRICT;";
			else
				if(wizard.FindSymbol('WINDOWS_APPLICATION_RADIO'))
					CLTool.PreprocessorDefinitions = "wxUSE_UNICODE=1;WIN32;_DEBUG;__WXDEBUG__;WXDEBUG=1;__WIN32__;__WXMSW__;WINVER=0x0400;STRICT;";
				else if(wizard.FindSymbol('DLL_APPLICATION_RADIO'))
					CLTool.PreprocessorDefinitions = "wxUSE_UNICODE=1;WIN32;_DEBUG;__WXDEBUG__;WXDEBUG=1;__WIN32__;__WXMSW__;WINVER=0x0400;STRICT;_USRDLL;WXMAKINGDLL_" + strProjectName + ";" + strProjectName + "DLL_EXPORTS";
				else
					CLTool.PreprocessorDefinitions = "wxUSE_UNICODE=1;WIN32;__WIN32__;_DEBUG;__WXMSW__;__WXDEBUG__;_CONSOLE;wxUSE_GUI=0";
		else
			if(wizard.FindSymbol('USE_DYNAMIC_LIBRARY_RADIO'))
				if(wizard.FindSymbol('WINDOWS_APPLICATION_RADIO'))
					CLTool.PreprocessorDefinitions = "WIN32;_DEBUG;__WXDEBUG__;WXDEBUG=1;__WIN32__;__WXMSW__;WINVER=0x0400;WXUSINGDLL;STRICT;";
				else if(wizard.FindSymbol('DLL_APPLICATION_RADIO'))
					CLTool.PreprocessorDefinitions = "WIN32;_DEBUG;__WXDEBUG__;WXDEBUG=1;__WIN32__;__WXMSW__;WINVER=0x0400;WXUSINGDLL;STRICT;_USRDLL;WXMAKINGDLL_" + strProjectName + ";" + strProjectName + "DLL_EXPORTS";
				else
					CLTool.PreprocessorDefinitions = "WIN32;_DEBUG;__WXMSW__;__WXDEBUG__;_CONSOLE;wxUSE_GUI=0;WXUSINGDLL;STRICT;";
			else
				if(wizard.FindSymbol('WINDOWS_APPLICATION_RADIO'))
					CLTool.PreprocessorDefinitions = "WIN32;_DEBUG;__WXDEBUG__;WXDEBUG=1;__WIN32__;__WXMSW__;WINVER=0x0400;STRICT;";
				else if(wizard.FindSymbol('DLL_APPLICATION_RADIO'))
					CLTool.PreprocessorDefinitions = "WIN32;_DEBUG;__WXDEBUG__;WXDEBUG=1;__WIN32__;__WXMSW__;WINVER=0x0400;STRICT;_USRDLL;WXMAKINGDLL_" + strProjectName + ";" + strProjectName + "DLL_EXPORTS";
				else
					CLTool.PreprocessorDefinitions = "WIN32;__WIN32__;_DEBUG;__WXMSW__;__WXDEBUG__;_CONSOLE;wxUSE_GUI=0";
		
        if(wizard.FindSymbol('EMPTY_PROJECT_CHECKBOX'))
			CLTool.UsePrecompiledHeader = pchOption.pchNone;
		else
			CLTool.UsePrecompiledHeader = pchOption.pchNone;

		CLTool.Detect64BitPortabilityProblems = true;
		CLTool.BufferSecurityCheck = true;
		CLTool.RuntimeTypeInfo= true;
		CLTool.PrecompiledHeaderFile = "$(IntDir)/$(TargetName).pch";
		CLTool.PrecompiledHeaderThrough = "stdwx.h";
		CLTool.ObjectFile = "$(IntDir)/";
		CLTool.ProgramDataBaseFileName = "$(IntDir)/vc70.pdb";
		CLTool.CompileAs = CompileAsOptions.compileAsCPlusPlus; 

		//****************************************************************************************************************************
		var LinkTool = config.Tools('VCLinkerTool');
		LinkTool.ProgramDatabaseFile = "$(OutDir)/" + strProjectName + ".pdb";
		LinkTool.GenerateDebugInformation = true;
		LinkTool.LinkIncremental = linkIncrementalYes;
		if(wizard.FindSymbol('DLL_APPLICATION_RADIO'))
			LinkTool.OutputFile = "$(OutDir)/" + strProjectName + ".dll";
		else
			LinkTool.OutputFile = "$(OutDir)/" + strProjectName + ".exe";
		LinkTool.SuppressStartupBanner=true;  // nologo

		if(wizard.FindSymbol('USE_DYNAMIC_LIBRARY_RADIO'))
			LinkTool.AdditionalLibraryDirectories = "\""+wizard.FindSymbol('WXDIR')+"\\lib\"; \""+wizard.FindSymbol('WXDIR')+"\\lib\\vc_dll\"";
		else
			LinkTool.AdditionalLibraryDirectories = "\""+wizard.FindSymbol('WXDIR')+"\\lib\"; \""+wizard.FindSymbol('WXDIR')+"\\lib\\vc_lib\"";

		if(wizard.FindSymbol('UNICODE_ENABLED_CHECKBOX'))
			LinkTool.AdditionalDependencies = "wxbase26ud_net.lib wxmsw26ud_core.lib wxmsw26ud_adv.lib wxbase26ud.lib wxtiffd.lib wxjpegd.lib wxpngd.lib wxzlibd.lib wxregexud.lib wxexpatd.lib winmm.lib comctl32.lib rpcrt4.lib wsock32.lib oleacc.lib odbc32.lib";
		else
			LinkTool.AdditionalDependencies = "wxbase26d_net.lib wxmsw26d_core.lib wxmsw26d_adv.lib wxbase26d.lib wxtiffd.lib wxjpegd.lib wxpngd.lib wxzlibd.lib wxregexd.lib wxexpatd.lib winmm.lib comctl32.lib rpcrt4.lib wsock32.lib oleacc.lib odbc32.lib";

		LinkTool.IgnoreDefaultLibraryNames = "MSVCRT.lib;LIBCD.lib;LIBCMTD.lib;LIBC.lib;LIBCMT.lib;"

		if(wizard.FindSymbol('WINDOWS_APPLICATION_RADIO') || wizard.FindSymbol('DLL_APPLICATION_RADIO'))
			LinkTool.SubSystem=subSystemOption.subSystemWindows;
		else
			LinkTool.SubSystem=subSystemOption.subSystemConsole;
		
		LinkTool.TargetMachine=machineTypeOption.machineX86; 
		
		// Post-build settings
        if(wizard.FindSymbol('USE_DYNAMIC_LIBRARY_RADIO'))
        {
			var PostBuildTool = config.Tools("VCPostBuildEventTool");
            PostBuildTool.Description = "Copying wxDll Files...";
            PostBuildTool.CommandLine = "copy \""+wizard.FindSymbol('WXDIR')+"\\lib\\vc_dll\\*.dll\" \"$(ProjectDir)\\\"";
        }

        if(wizard.FindSymbol('WINDOWS_APPLICATION_RADIO') || wizard.FindSymbol('DLL_APPLICATION_RADIO'))
        {
			var resourceTool = config.Tools("VCResourceCompilerTool");
            resourceTool.Culture = rcEnglishUS;
			resourceTool.AdditionalIncludeDirectories  = resourceTool.AdditionalIncludeDirectories + "\""+wizard.FindSymbol('WXDIR')+"\\include\"";
			if(wizard.FindSymbol('UNICODE_ENABLED_CHECKBOX'))
				if(wizard.FindSymbol('USE_DYNAMIC_LIBRARY_RADIO'))
					if(wizard.FindSymbol('WINDOWS_APPLICATION_RADIO'))
						resourceTool.PreprocessorDefinitions = "wxUSE_UNICODE=1;_DEBUG;__WXDEBUG__;WXDEBUG=1;WIN32;__WIN32__;__WXMSW__;WINVER=0x0400;WXUSINGDLL;STRICT;";
					else
						resourceTool.PreprocessorDefinitions = "wxUSE_UNICODE=1;_DEBUG;__WXDEBUG__;WXDEBUG=1;WIN32;__WIN32__;__WXMSW__;WINVER=0x0400;WXUSINGDLL;STRICT;_USRDLL;WXMAKINGDLL_" + strProjectName + ";" + strProjectName + "DLL_EXPORTS";
				else
					if(wizard.FindSymbol('WINDOWS_APPLICATION_RADIO'))
						resourceTool.PreprocessorDefinitions = "wxUSE_UNICODE=1;_DEBUG;__WXDEBUG__;WXDEBUG=1;WIN32;__WIN32__;__WXMSW__;WINVER=0x0400;STRICT;";
					else
						resourceTool.PreprocessorDefinitions = "wxUSE_UNICODE=1;_DEBUG;__WXDEBUG__;WXDEBUG=1;WIN32;__WIN32__;__WXMSW__;WINVER=0x0400;STRICT;_USRDLL;WXMAKINGDLL_" + strProjectName + ";" + strProjectName + "DLL_EXPORTS";
			else
				if(wizard.FindSymbol('USE_DYNAMIC_LIBRARY_RADIO'))
					if(wizard.FindSymbol('WINDOWS_APPLICATION_RADIO'))
						resourceTool.PreprocessorDefinitions = "_DEBUG;__WXDEBUG__;WXDEBUG=1;WIN32;__WIN32__;__WXMSW__;WINVER=0x0400;WXUSINGDLL;STRICT;";
					else
						resourceTool.PreprocessorDefinitions = "_DEBUG;__WXDEBUG__;WXDEBUG=1;WIN32;__WIN32__;__WXMSW__;WINVER=0x0400;WXUSINGDLL;STRICT;_USRDLL;WXMAKINGDLL_" + strProjectName + ";" + strProjectName + "DLL_EXPORTS";
				else
					if(wizard.FindSymbol('WINDOWS_APPLICATION_RADIO'))
						resourceTool.PreprocessorDefinitions = "_DEBUG;__WXDEBUG__;WXDEBUG=1;WIN32;__WIN32__;__WXMSW__;WINVER=0x0400;STRICT;";
					else
						resourceTool.PreprocessorDefinitions = "_DEBUG;__WXDEBUG__;WXDEBUG=1;WIN32;__WIN32__;__WXMSW__;WINVER=0x0400;STRICT;_USRDLL;WXMAKINGDLL_" + strProjectName + ";" + strProjectName + "DLL_EXPORTS";
        }

		//****************************************************************************************************************************
		config = proj.Object.Configurations('Release');
		config.IntermediateDirectory = 'Release';
		config.OutputDirectory = 'Release';

		if(wizard.FindSymbol('UNICODE_ENABLED_CHECKBOX'))
		{
			config.CharacterSet = charSetUnicode;
			if(wizard.FindSymbol('DLL_APPLICATION_RADIO'))
			{
				config.ConfigurationType  = typeDynamicLibrary;
			}
		}
		else
		{
			config.CharacterSet = charSetNotSet;
			if(wizard.FindSymbol('DLL_APPLICATION_RADIO'))
			{
				config.ConfigurationType  = typeDynamicLibrary;
			}
		}

		var CLTool = config.Tools('VCCLCompilerTool');
		CLTool.DebugInformationFormat = debugDisabled;
		CLTool.SuppressStartupBanner=true;
		CLTool.RuntimeLibrary = runtimeLibraryOption.rtMultiThreadedDll;
		CLTool.WarningLevel=warningLevelOption.warningLevel_4;
		CLTool.Optimization=optimizeOption.optimizeMaxSpeed;
		CLTool.MinimalRebuild=false;
		CLTool.InlineFunctionExpansion = expandOnlyInline;
		if(wizard.FindSymbol('USE_DYNAMIC_LIBRARY_RADIO'))
			if(wizard.FindSymbol('UNICODE_ENABLED_CHECKBOX'))
				CLTool.AdditionalIncludeDirectories = "\""+wizard.FindSymbol('WXDIR')+"\\include\";\""+wizard.FindSymbol('WXDIR')+"\\lib\\vc_dll\\mswu\";\""+wizard.FindSymbol('WXDIR')+"\\contrib\\include\"";
			else
				CLTool.AdditionalIncludeDirectories = "\""+wizard.FindSymbol('WXDIR')+"\\include\";\""+wizard.FindSymbol('WXDIR')+"\\lib\\vc_dll\\msw\";\""+wizard.FindSymbol('WXDIR')+"\\contrib\\include\"";
		else
			if(wizard.FindSymbol('UNICODE_ENABLED_CHECKBOX'))
				CLTool.AdditionalIncludeDirectories = "\""+wizard.FindSymbol('WXDIR')+"\\include\";\""+wizard.FindSymbol('WXDIR')+"\\lib\\vc_lib\\mswu\";\""+wizard.FindSymbol('WXDIR')+"\\contrib\\include\"";
			else
				CLTool.AdditionalIncludeDirectories = "\""+wizard.FindSymbol('WXDIR')+"\\include\";\""+wizard.FindSymbol('WXDIR')+"\\lib\\vc_lib\\msw\";\""+wizard.FindSymbol('WXDIR')+"\\contrib\\include\"";
		
		if(wizard.FindSymbol('UNICODE_ENABLED_CHECKBOX'))
			if(wizard.FindSymbol('USE_DYNAMIC_LIBRARY_RADIO'))
				if(wizard.FindSymbol('WINDOWS_APPLICATION_RADIO'))
					CLTool.PreprocessorDefinitions = "wxUSE_UNICODE=1;WIN32;__WIN32__;__WXMSW__;WXUSINGDLL;_WINDOWS;";
				else if(wizard.FindSymbol('DLL_APPLICATION_RADIO'))
					CLTool.PreprocessorDefinitions = "wxUSE_UNICODE=1;WIN32;__WIN32__;__WXMSW__;WXUSINGDLL;_WINDOWS;_USRDLL;WXMAKINGDLL_" + strProjectName + ";" + strProjectName + "DLL_EXPORTS";
				else
					CLTool.PreprocessorDefinitions = "wxUSE_UNICODE=1;WIN32;__WIN32__;__WXMSW__;WXUSINGDLL;_CONSOLE;wxUSE_GUI=0";
			else
				if(wizard.FindSymbol('WINDOWS_APPLICATION_RADIO'))
					CLTool.PreprocessorDefinitions = "wxUSE_UNICODE=1;WIN32;__WIN32__;__WXMSW__;_WINDOWS;";
				else if(wizard.FindSymbol('DLL_APPLICATION_RADIO'))
					CLTool.PreprocessorDefinitions = "wxUSE_UNICODE=1;WIN32;__WIN32__;__WXMSW__;_WINDOWS;_USRDLL;WXMAKINGDLL_" + strProjectName + ";" + strProjectName + "DLL_EXPORTS";
				else
					CLTool.PreprocessorDefinitions = "wxUSE_UNICODE=1;WIN32;__WIN32__;__WXMSW__;_CONSOLE;wxUSE_GUI=0";
		else
			if(wizard.FindSymbol('USE_DYNAMIC_LIBRARY_RADIO'))
				if(wizard.FindSymbol('WINDOWS_APPLICATION_RADIO'))
					CLTool.PreprocessorDefinitions = "WIN32;__WIN32__;__WXMSW__;WXUSINGDLL;_WINDOWS;";
				else if(wizard.FindSymbol('DLL_APPLICATION_RADIO'))
					CLTool.PreprocessorDefinitions = "WIN32;__WIN32__;__WXMSW__;WXUSINGDLL;_WINDOWS;_USRDLL;WXMAKINGDLL_" + strProjectName + ";" + strProjectName + "DLL_EXPORTS";
				else
					CLTool.PreprocessorDefinitions = "WIN32;__WIN32__;__WXMSW__;WXUSINGDLL;_CONSOLE;wxUSE_GUI=0";
			else
				if(wizard.FindSymbol('WINDOWS_APPLICATION_RADIO'))
					CLTool.PreprocessorDefinitions = "WIN32;__WIN32__;__WXMSW__;_WINDOWS;";
				else if(wizard.FindSymbol('DLL_APPLICATION_RADIO'))
					CLTool.PreprocessorDefinitions = "WIN32;__WIN32__;__WXMSW__;_WINDOWS;_USRDLL;WXMAKINGDLL_" + strProjectName + ";" + strProjectName + "DLL_EXPORTS";
				else
					CLTool.PreprocessorDefinitions = "WIN32;__WIN32__;__WXMSW__;_CONSOLE;wxUSE_GUI=0";
		
        if(wizard.FindSymbol('EMPTY_PROJECT_CHECKBOX'))
			CLTool.UsePrecompiledHeader = pchOption.pchNone;
		else
			CLTool.UsePrecompiledHeader = pchOption.pchNone;

		CLTool.Detect64BitPortabilityProblems = true;
		CLTool.BufferSecurityCheck = true;
		CLTool.RuntimeTypeInfo= true;
		CLTool.PrecompiledHeaderFile = "$(IntDir)/$(TargetName).pch";
		CLTool.PrecompiledHeaderThrough = "stdwx.h";
		CLTool.ObjectFile = "$(IntDir)/";
		CLTool.ProgramDataBaseFileName = "$(IntDir)/vc70.pdb";
		CLTool.CompileAs = CompileAsOptions.compileAsCPlusPlus;  
		//CLTool.ExceptionHandling = True;
		CLTool.StringPooling = true;  

		//****************************************************************************************************************************
		var LinkTool = config.Tools('VCLinkerTool');

		if(wizard.FindSymbol('UNICODE_ENABLED_CHECKBOX'))
			LinkTool.AdditionalDependencies = "wxbase26u_net.lib wxmsw26u_core.lib wxmsw26u_adv.lib wxbase26u.lib wxtiffd.lib wxjpegd.lib wxpngd.lib wxzlibd.lib wxregexu.lib wxexpat.lib winmm.lib comctl32.lib rpcrt4.lib wsock32.lib oleacc.lib odbc32.lib";
		else
			LinkTool.AdditionalDependencies = "wxbase26_net.lib wxmsw26_adv.lib wxbase26.lib wxtiff.lib wxjpeg.lib wxmsw26_core.lib wxpng.lib wxzlib.lib wxregex.lib wxexpat.lib winmm.lib comctl32.lib rpcrt4.lib wsock32.lib oleacc.lib odbc32.lib";
		
		LinkTool.IgnoreDefaultLibraryNames = "MSVCRTD.lib;LIBCMT.lib;LIBC.lib;LIBCMTD.lib;LIBCD.lib"

		LinkTool.ProgramDatabaseFile = "$(OutDir)/" + strProjectName + ".pdb";
		LinkTool.GenerateDebugInformation = false;
		LinkTool.LinkIncremental = linkIncrementalNo;
		if(wizard.FindSymbol('DLL_APPLICATION_RADIO'))
			LinkTool.OutputFile = "$(OutDir)/" + strProjectName + ".dll";
		else
			LinkTool.OutputFile = "$(OutDir)/" + strProjectName + ".exe";
		LinkTool.SuppressStartupBanner=true;  // nologo

		if(wizard.FindSymbol('USE_DYNAMIC_LIBRARY_RADIO'))
			LinkTool.AdditionalLibraryDirectories = "\""+wizard.FindSymbol('WXDIR')+"\\lib\"; \""+wizard.FindSymbol('WXDIR')+"\\lib\\vc_dll\"";
		else
			LinkTool.AdditionalLibraryDirectories = "\""+wizard.FindSymbol('WXDIR')+"\\lib\"; \""+wizard.FindSymbol('WXDIR')+"\\lib\\vc_lib\"";

		if(wizard.FindSymbol('WINDOWS_APPLICATION_RADIO') || wizard.FindSymbol('DLL_APPLICATION_RADIO'))
			LinkTool.SubSystem=subSystemOption.subSystemWindows;
		else
			LinkTool.SubSystem=subSystemOption.subSystemConsole;

		LinkTool.TargetMachine=machineTypeOption.machineX86; 
		
        // Post-build settings
        if(wizard.FindSymbol('USE_DYNAMIC_LIBRARY_RADIO'))
        {
			var PostBuildTool = config.Tools("VCPostBuildEventTool");
            PostBuildTool.Description = "Copying wxDll Files...";
            PostBuildTool.CommandLine = "copy \""+wizard.FindSymbol('WXDIR')+"\\lib\\vc_dll\\*.dll\" \"$(ProjectDir)\\\"";
        }

       if(wizard.FindSymbol('WINDOWS_APPLICATION_RADIO') || wizard.FindSymbol('DLL_APPLICATION_RADIO'))
        {
			var resourceTool = config.Tools("VCResourceCompilerTool");
            resourceTool.Culture = rcEnglishUS;
			resourceTool.AdditionalIncludeDirectories  = resourceTool.AdditionalIncludeDirectories + "\""+wizard.FindSymbol('WXDIR')+"\\include\"";
			if(wizard.FindSymbol('UNICODE_ENABLED_CHECKBOX'))
				if(wizard.FindSymbol('USE_DYNAMIC_LIBRARY_RADIO'))
					if(wizard.FindSymbol('WINDOWS_APPLICATION_RADIO'))
						resourceTool.PreprocessorDefinitions = "wxUSE_UNICODE=1;WIN32;__WXMSW__;WXUSINGDLL;_WINDOWS;";
					else
						resourceTool.PreprocessorDefinitions = "wxUSE_UNICODE=1;WIN32;__WXMSW__;WXUSINGDLL;_WINDOWS;_USRDLL;WXMAKINGDLL_" + strProjectName + ";" + strProjectName + "DLL_EXPORTS";
				else
					if(wizard.FindSymbol('WINDOWS_APPLICATION_RADIO'))
						resourceTool.PreprocessorDefinitions = "wxUSE_UNICODE=1;WIN32;__WXMSW__;_WINDOWS;";
					else
						resourceTool.PreprocessorDefinitions = "wxUSE_UNICODE=1;WIN32;__WXMSW__;_WINDOWS;_USRDLL;WXMAKINGDLL_" + strProjectName + ";" + strProjectName + "DLL_EXPORTS";
			else
				if(wizard.FindSymbol('USE_DYNAMIC_LIBRARY_RADIO'))
					if(wizard.FindSymbol('WINDOWS_APPLICATION_RADIO'))
						resourceTool.PreprocessorDefinitions = "WIN32;__WXMSW__;WXUSINGDLL;_WINDOWS;";
					else
						resourceTool.PreprocessorDefinitions = "WIN32;__WXMSW__;WXUSINGDLL;_WINDOWS;_USRDLL;WXMAKINGDLL_" + strProjectName + ";" + strProjectName + "DLL_EXPORTS";
				else
					if(wizard.FindSymbol('WINDOWS_APPLICATION_RADIO'))
						resourceTool.PreprocessorDefinitions = "WIN32;__WXMSW__;_WINDOWS;";
					else
						resourceTool.PreprocessorDefinitions = "WIN32;__WXMSW__;_WINDOWS;_USRDLL;WXMAKINGDLL_" + strProjectName + ";" + strProjectName + "DLL_EXPORTS";
        }
	}
	catch(e)
	{
		throw e;
	}
}

function PchSettings(oProj)
{
	try
	{
		for (var i = 1; i <= oProj.Object.Configurations.Count; i++)
		{
			var config = oProj.Object.Configurations.Item(i);
			var CLTool = config.Tools("VCCLCompilerTool");
			CLTool.UsePrecompiledHeader = pchNone;
		}
	}
	catch(e)
	{
		throw e;
	}
}

function DelFile(fso, strWizTempFile)
{
	try
	{
		if (fso.FileExists(strWizTempFile))
		{
			var tmpFile = fso.GetFile(strWizTempFile);
			tmpFile.Delete();
		}
	}
	catch(e)
	{
		throw e;
	}
}

function CreateCustomInfFile()
{
	try
	{
		var fso, TemplatesFolder, TemplateFiles, strTemplate;
		fso = new ActiveXObject('Scripting.FileSystemObject');

		var TemporaryFolder = 2;
		var tfolder = fso.GetSpecialFolder(TemporaryFolder);
		var strTempFolder = tfolder.Drive + '\\' + tfolder.Name;

		var strWizTempFile = strTempFolder + "\\" + fso.GetTempName();

		var strTemplatePath = wizard.FindSymbol('TEMPLATES_PATH');
		var strInfFile = strTemplatePath + '\\Templates.inf';
		wizard.RenderTemplate(strInfFile, strWizTempFile);

		var WizTempFile = fso.GetFile(strWizTempFile);
		return WizTempFile;
	}
	catch(e)
	{
		throw e;
	}
}

function GetTargetName(strName, strProjectName)
{
	try
	{
		// set the name of the rendered file based on the template filename
		var strTarget = strName;

		if (strName == 'temp0.wxr')
			strTarget = strProjectName + ".rc";

		if (strName == 'temp1.wxr')
			strTarget = 'ReadMe.txt';

		if (strName == 'temp2.ico')
			strTarget = "res\\" + strProjectName + ".ico";

		if (strName == 'temp1.wxh')
			strTarget = strProjectName + "_App.h";

		if (strName == 'temp3.wxc')
			strTarget = strProjectName + "DLL.cpp";

		if (strName == 'temp3.wxh')
			strTarget = strProjectName + "DLL.h";

		if (strName == 'temp1.wxc')
			strTarget = strProjectName + "_App.cpp";

		if (strName == 'temp4.wxc')
			strTarget = strProjectName + ".cpp";

		if (strName == 'temp2.wxh')
			strTarget = strProjectName + "_Frm.h";

		if (strName == 'temp2.wxc')
			strTarget = strProjectName + "_Frm.cpp";

		if (strName == 'temp5.wxh')
			strTarget = strProjectName + "_Dlg.h";

		if (strName == 'temp5.wxc')
			strTarget = strProjectName + "_Dlg.cpp";

		if (strName == 'temp4.wxh')
			strTarget = 'stdwx.h';

		if (strName == 'copy.bmp')
			strTarget = 'res\\copy.bmp';

		if (strName == 'cut.bmp')
			strTarget = 'res\\cut.bmp';
		
		if (strName == 'help.bmp')
			strTarget = 'res\\help.bmp';
		
		if (strName == 'new.bmp')
			strTarget = 'res\\new.bmp';
		
		if (strName == 'open.bmp')
			strTarget = 'res\\open.bmp';

		if (strName == 'open.bmp')
			strTarget = 'res\\open.bmp';

		if (strName == 'open.bmp')
			strTarget = 'res\\open.bmp';

		if (strName == 'page.bmp')
			strTarget = 'res\\page.bmp';

		if (strName == 'paste.bmp')
			strTarget = 'res\\paste.bmp';

		if (strName == 'preview.bmp')
			strTarget = 'res\\preview.bmp';

		if (strName == 'print.bmp')
			strTarget = 'res\\print.bmp';

		if (strName == 'save.bmp')
			strTarget = 'res\\save.bmp';

		if (strName == 'wxFormBuilder.fbp')
			strTarget = 'res\\' + strProjectName + '.fbp';

		if (strName == 'temp6.wxc')
			strTarget = strProjectName + "Resources.cpp";

		if (strName == 'temp6.wxh')
			strTarget = strProjectName + "Resources.h";;

		return strTarget; 
	}
	catch(e)
	{
		throw e;
	}
}

function AddFilesToCustomProj(proj, strProjectName, strProjectPath, InfFile)
{
	try
	{
		var projItems = proj.ProjectItems

		var strTemplatePath = wizard.FindSymbol('TEMPLATES_PATH');

		var strTpl = '';
		var strName = '';

		var strTextStream = InfFile.OpenAsTextStream(1, -2);
		while (!strTextStream.AtEndOfStream)
		{
			strTpl = strTextStream.ReadLine();
			if (strTpl != '')
			{
				strName = strTpl;
				var strTarget = GetTargetName(strName, strProjectName);
				var strTemplate = strTemplatePath + '\\' + strTpl;
				var strFile = strProjectPath + '\\' + strTarget;

				var bCopyOnly = false;  //"true" will only copy the file from strTemplate to strTarget without rendering/adding to the project
				var strExt = strName.substr(strName.lastIndexOf("."));
				if(strExt==".bmp" || strExt==".ico" || strExt==".gif" || strExt==".rtf" || strExt==".css")
					bCopyOnly = true;
				wizard.RenderTemplate(strTemplate, strFile, bCopyOnly);
				proj.Object.AddFile(strFile);
			}
		}
		strTextStream.Close();
	}
	catch(e)
	{
		throw e;
	}
}
